from five import grok
from zope import schema
from zope.interface import Interface
from zope.component import getUtility
from plone.app.registry.browser.controlpanel import ControlPanelFormWrapper
from plone.app.registry.browser.controlpanel import RegistryEditForm
from plone.registry.interfaces import IRecordModifiedEvent
from plone.z3cform import layout
from Products.CMFPlone.interfaces import IPloneSiteRoot
from zope.schema.vocabulary import SimpleVocabulary, SimpleTerm

class IEditablesvgSettings(Interface):
    svgediturl = schema.TextLine(title=u"URL to svg-edit sources", 
                                 description=u"""
        You can change the URL to the svg-edit sources. So for example you could use the trunk of svg-edit
        by entering http://svg-edit.googlecode.com/svn/trunk/editor/. A fresh installation uses 
        ++resource++collective.editablesvg/svg-edit/ which means it uses the sources provided with this add-on.""",
                                 default=u"++resource++collective.editablesvg/svg-edit/")
    height = schema.Int(title=u"svg-edit widget height",
                        default=660)
    iconsize = schema.Choice(title=u"Size of the svg-edit icons", 
                             vocabulary=SimpleVocabulary([SimpleTerm(value=u"m", title=u'medium'),
                                                          SimpleTerm(value=u"l", title=u'large'),
                                                          SimpleTerm(value=u"xl", title=u'extra large')]))

class EditablesvgControlPanelForm(RegistryEditForm):
    schema = IEditablesvgSettings
        
    def updateWidgets(self):
        super(EditablesvgControlPanelForm, self).updateWidgets()
        self.widgets['svgediturl'].size = 80

EditablesvgControlPanelView = layout.wrap_form(EditablesvgControlPanelForm, ControlPanelFormWrapper)
EditablesvgControlPanelView.label = u"Editablesvg settings"

@grok.subscribe(IEditablesvgSettings, IRecordModifiedEvent)
def detectSvgeditUrlChange(settings, event):
    if('svgediturl' in event.record.fieldName):
        newurl = "%s/embedapi.js" % event.newValue.strip('/')
        oldurl = "%s/embedapi.js" % event.oldValue.strip('/')
        siteroot = getUtility(IPloneSiteRoot)
        JSRegistry = siteroot.portal_javascripts
        JSRegistry.unregisterResource(oldurl)
        JSRegistry.registerScript(newurl, expression='', inline=False, enabled=1, cookable=True, 
                                      compression='safe', cacheable=True)
