import xml.dom
import tempfile
import os
from collective.editablesvg import _
from five import grok
from plone.directives import form
from plone.namedfile import field
from plone import namedfile
from reportlab.graphics import renderPM
from svglib.svglib import SvgRenderer
from widget import SvgeditFieldWidget
from zope.lifecycleevent.interfaces import IObjectModifiedEvent, IObjectAddedEvent
from zope import schema

class ISvgImage(form.Schema):
    title = schema.TextLine(
            title=_(u"Name"),
        )
    
    description = schema.Text(
            title=_(u"A short description"),
            required=False,
        )
    
    form.widget(svg=SvgeditFieldWidget)
    svg = schema.Text(
            title=_(u"The SVG graphic"),
        )
    
    form.omitted('bitmap')
    bitmap = field.NamedBlobImage(
            title=_(u"Bitmap"),
            description=_(u"The SVG graphic stored in PNG format"),
            required=False,
        )

class View(grok.View):
    grok.context(ISvgImage)
    grok.require('zope2.View')
    
def generatePng(contentobject):
    svgrenerer = SvgRenderer()
    svgxml = xml.dom.minidom.parseString(contentobject.svg)
    svgrenerer.render(svgxml.documentElement)
    drawing = svgrenerer.finish()
    tempfilename = tempfile.NamedTemporaryFile().name + ".png"
    renderPM.drawToFile(drawing, tempfilename, fmt='png')
    filecontent = open(tempfilename, 'rb').read()
    os.remove(tempfilename)
    return filecontent

@grok.subscribe(ISvgImage, IObjectModifiedEvent)
def changeImage(contentobject, event):
    contentobject.bitmap.data = generatePng(contentobject)

@grok.subscribe(ISvgImage, IObjectAddedEvent)
def addImage(contentobject, event):
    contentobject.bitmap = namedfile.NamedBlobImage(generatePng(contentobject), filename=contentobject.title + '.png')
