import zope.interface
import zope.schema.interfaces
from plone.registry.interfaces import IRegistry
from zope.component import getUtility
from z3c.form.browser.textarea import TextAreaWidget
from z3c.form.widget import FieldWidget
from z3c.form import interfaces

class ISvgeditWidget(interfaces.ITextAreaWidget):
    pass

class SvgeditWidget(TextAreaWidget):
    zope.interface.implementsOnly(ISvgeditWidget)
    
    def svgeditorurl(self):
        registry = getUtility(IRegistry)
        urlbase = registry.get('collective.editablesvg.controlpanel.IEditablesvgSettings.svgediturl').strip('/')
        iconsize = registry.get('collective.editablesvg.controlpanel.IEditablesvgSettings.iconsize')
        return "%s/svg-editor.html?no_save_warning=true&iconsize=%s" % (urlbase, iconsize)
    def svgeditorheight(self):
        registry = getUtility(IRegistry)
        return registry.get('collective.editablesvg.controlpanel.IEditablesvgSettings.height')

@zope.component.adapter(zope.schema.interfaces.IField, interfaces.IFormLayer)
@zope.interface.implementer(interfaces.IFieldWidget)
def SvgeditFieldWidget(field, request):
    """IFieldWidget factory for TextWidget."""
    return FieldWidget(field, SvgeditWidget(request))
